// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'CandleCh.pas' rev: 3.00

#ifndef CandleChHPP
#define CandleChHPP
#include <TeCanvas.hpp>
#include <TeEngine.hpp>
#include <OHLChart.hpp>
#include <Series.hpp>
#include <Chart.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Candlech
{
//-- type declarations -------------------------------------------------------
enum TCandleStyle { csCandleStick, csCandleBar };

class DELPHICLASS TCandleSeries;
class PASCALIMPLEMENTATION TCandleSeries : public Ohlchart::TOHLCSeries 
{
	typedef Ohlchart::TOHLCSeries inherited;
	
private:
	int FCandleWidth;
	TCandleStyle FCandleStyle;
	Graphics::TColor FUpCloseColor;
	Graphics::TColor FDownCloseColor;
	bool FShowOpenTick;
	bool FShowCloseTick;
	
protected:
	virtual void __fastcall DrawValue(int ValueIndex);
	void __fastcall SetShowOpenTick(bool Value);
	void __fastcall SetShowCloseTick(bool Value);
	void __fastcall SetUpColor(Graphics::TColor Value);
	void __fastcall SetDownColor(Graphics::TColor Value);
	void __fastcall SetCandleWidth(int Value);
	void __fastcall SetCandleStyle(TCandleStyle Value);
	bool __fastcall GetDraw3D(void);
	void __fastcall SetDraw3D(bool Value);
	bool __fastcall GetDark3D(void);
	HIDESBASE void __fastcall SetDark3D(bool Value);
	Graphics::TPen* __fastcall GetPen(void);
	void __fastcall SetPen(Graphics::TPen* Value);
	
public:
	__fastcall virtual TCandleSeries(Classes::TComponent* AOwner);
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	int __fastcall AddCandle(const System::TDateTime ADate, const double AOpen, const double AHigh, const 
		double ALow, const double AClose);
	virtual System::AnsiString __fastcall GetEditorClass();
	
__published:
	__property TCandleStyle CandleStyle = {read=FCandleStyle, write=SetCandleStyle, default=0};
	__property int CandleWidth = {read=FCandleWidth, write=SetCandleWidth, default=5};
	__property bool Draw3D = {read=GetDraw3D, write=SetDraw3D, default=0};
	__property bool Dark3D = {read=GetDark3D, write=SetDark3D, default=1};
	__property Graphics::TColor DownCloseColor = {read=FDownCloseColor, write=SetDownColor, default=255
		};
	__property bool ShowCloseTick = {read=FShowCloseTick, write=SetShowCloseTick, default=1};
	__property bool ShowOpenTick = {read=FShowOpenTick, write=SetShowOpenTick, default=1};
	__property Graphics::TColor UpCloseColor = {read=FUpCloseColor, write=SetUpColor, default=16777215}
		;
	__property Graphics::TPen* Pen = {read=GetPen, write=SetPen};
public:
	/* TCustomSeries.Destroy */ __fastcall virtual ~TCandleSeries(void) { }
	
};

class DELPHICLASS TVolumeSeries;
class PASCALIMPLEMENTATION TVolumeSeries : public Series::TCustomSeries 
{
	typedef Series::TCustomSeries inherited;
	
protected:
	Teengine::TChartValueList* __fastcall GetVolumeValues(void);
	void __fastcall SetVolumeValues(Teengine::TChartValueList* Value);
	virtual void __fastcall DrawValue(int ValueIndex);
	
public:
	__fastcall virtual TVolumeSeries(Classes::TComponent* AOwner);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual int __fastcall NumSampleValues(void);
	virtual void __fastcall FillSampleValues(int NumValues);
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	
__published:
	__property LinePen ;
	__property Teengine::TChartValueList* VolumeValues = {read=GetVolumeValues, write=SetVolumeValues};
		
	__property XValues ;
public:
	/* TCustomSeries.Destroy */ __fastcall virtual ~TVolumeSeries(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define DefCandleWidth (Byte)(5)

}	/* namespace Candlech */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Candlech;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// CandleCh
